import java.awt.*;
import java.applet.*;

//::::::::::::::
//Environment.class
//::::::::::::::
    
class Environment extends Canvas {
    Graphics g;
    Rectangle box = new Rectangle(0,0,620,300);
//	Backround variables
    int Xp1 [] = { 20, 200, 300, 300, 20 , 20};
    int Yp1 [] = { 20, 200, 200, 250, 250, 20};
    int Xp2 [] = { 320, 420, 600, 600 ,320, 320};
    int Yp2 [] = { 200, 200, 20 , 250, 250, 200};
    Rectangle way = new Rectangle(0,300,620,10);
 
    Ball b1=null; Ball b2=null; Ball b3=null;
    int IN=0;
    Carrier car=null;
    boolean LOADING=false;
    boolean TOKEN=true;
    public Environment() {
	super();
	setBackground(Color.blue);
	setForeground(Color.yellow);
    } 

    public void paint(Graphics g) {
	super.paint(g);
	g.setColor(Color.gray);
	g.fillPolygon(Xp1,Yp1,Xp1.length);
	g.fillPolygon(Xp2,Yp2,Xp2.length);
	g.setColor(Color.black);
	g.fillRect(0,300,620,100);
	g.setColor(Color.yellow);
	g.drawPolygon(Xp1,Yp1,Xp1.length);
	g.drawPolygon(Xp2,Yp2,Xp2.length);
		
	g.setColor(Color.black);
	g.fillRect(310,0,1,145);
	g.fillRect(303,145,14,30);
	g.setColor(Color.red);

	g.fillOval(305,160,10,10);
	g.setColor(Color.green);g.fillOval(305,148,10,10);
	g.setXORMode(Color.gray);
	g.fillOval(305,148,10,10);
	g.dispose();
    }
    private void switchStopSign(boolean mode)   //repaint stop sign by using xor mode
    {    
	Graphics g=this.getGraphics(); 
	g.setColor(Color.red);g.setXORMode(Color.gray);
	g.fillOval(305,160,10,10);
	g.setColor(Color.green);g.setXORMode(Color.gray);
	g.fillOval(305,148,10,10);
	g.dispose();
    }
    
    public synchronized boolean carReady() {
	while ( !LOADING )
	    {  try {wait();} catch(InterruptedException e){} 
	    }
	notify();
	return true;
    }
    public synchronized void waitLoadQueue (Ball b) {
	if ( carReady() ) {            //wait for the car si ready, if no it will wait in method carready()
	    b3=b2;
	    b2=b1;
	    b1=b;
	    if (b3 != null) {
		LOADING=false;
		switchStopSign(true); //switchStopSign();
		car.b1=b1;
		car.b2=b2;
		car.b3=b3;
		b1=null;
		b2=null;
		b3=null;
	    }
	}
	b.haveTICKET=true;
	b.beNice(); // wait a little bit
    }
    private void moveCar(){
	car.refresh();
	car.resume();
	car.showStopSign(); //close the stop signs
	car.PERMIT=getPermit_cancelPermit(true);
    }

    public synchronized boolean getPermit_cancelPermit(boolean hasPermit) {

	if (!hasPermit) {              //get permission for the loading
	    while ( !TOKEN )       //wait until token is available
		{ try {wait();} catch(InterruptedException e){} }
	    TOKEN=false;
	    return true;
	}
	else { TOKEN=true; notify(); notify(); return false;  }     //give the permission,token
    }
    public synchronized void getinCar(Ball b) { //the ball get in the car
	b.haveTICKET=false;
	IN+=1;
	if (IN==3) {   //last one drops
	    IN=0;
	    moveCar(); // car is ready to go
	} 
    }
    public void loadCarrier(Carrier _car) {  //car is empty and ready to be load
	switchStopSign(true);      // turn the green light on  
	car =_car;
	LOADING=true;                // will load the car
	carReady();                  // give signal to the wating balls for the loading
	car.suspend();                // take a break while loading
    }
	
	
    public void nextOfBall(Ball b){ //will decide the next movement of a ball by using its current place
	int x=b.where.x;  //get current place of the ball
	int y=b.where.y;  
	int dx=b.dx;      //get the speed of the ball
	int dy=b.dy;
	String direct=b.towards;    //cureren direction of the ball
		
	if (direct.equals("UP")){            //going up
	    if ( y > 10 ) { y=y-dy; }
	    else { y=10;
	    if (x < 30 ) {  direct="RIGHT"; }
	    else {direct="LEFT";}
	    }
	} 
	else if (direct.equals("RIGHT")){         //going right
	    x=x+dx;
	    if ( x < 30 ) { x= 24; direct="RIGHTDOWN"; } 
	    else if ( x >= 310 ) { x=310; direct="DOWN"; }
	    else if ( (x >= 300) && !b.haveTICKET ) { x=300; waitLoadQueue(b);  } //get a ticket, ie. wait green light
	} 
	else if (direct.equals("LEFT")){   //going left
	    x=x-dx;
	    if ( x > 550 ) { x= 596; direct="LEFTDOWN";}
	    else if ( x <= 310 ) { x=310;  direct="DOWN";  }
	    else if ( (x <= 320) && !b.haveTICKET ) { x=320; waitLoadQueue(b);  }//get a ticket, ie. wait green light
	} 
	else if (direct.equals("RIGHTDOWN")){ //
	    x=x+dx;
	    y=y+dx;
	    if ( y >= 190 ) { y=190; direct="RIGHT";}
	} 
	else if (direct.equals("LEFTDOWN")){
	    x=x-dx;
	    y=y+dx;
	    if ( y >= 190 ) { y=190; direct="LEFT";}
	}
	else if (direct.equals("DOWN")){        //falling down
	    y=y+dx;
	    if ( y>=box.height-15) { 
		y= box.height-15; direct="UP"; 
		x= car.raisefrom.x;
		getinCar(b);                        //get in car
//		b.disappear(this);
		b.suspend();                        //WAIT while car is moving
	    }
	} 
	b.next.x=x;                               // go to the next position
	b.next.y=y;
	b.towards=direct;
    }

}  //class Environment is finished

//_/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ 
// _/ _/ _/ _/ _/_/ _/ _/  CARRIER   _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ 
//_/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/


class Carrier extends Thread {
    Ball b1;
    Ball b2;
    Ball b3;
    mPoint p1 = new mPoint();
    mPoint p2 = new mPoint();
    mPoint p3 = new mPoint();
    mPoint raisefrom = new mPoint();
    Environment fab;
    String whichami;
    SyncApplet applet;
    String myball;
    boolean PERMIT=false;           //does not have the loading permission
    mPoint whereami = new mPoint();
    int center;
    int dx=5;                   //current speed
    boolean LOADING=false;    //current state
    boolean UNLOADING=true;
    boolean LOADED=true;
    
    public Carrier ( Environment _fab,String _whichami,SyncApplet _f) { // carrier constructor
	fab = _fab; whichami=_whichami; 
	applet = _f;
	if (whichami.equals("LEFT_CARRIER")){ //in case of the left carrier
	    p1.x=fab.box.x+10;
	    p1.y=fab.box.height-15;			
	    p2.x=p1.x+20; p2.y=p1.y;
	    p3.x=p2.x+20; p3.y=p2.y;
	    raisefrom.x=p1.x;
	    raisefrom.y=p1.y;
	    myball="grenbull.gif";
			
	} else {
	    p1.x=fab.box.width-10;
	    p1.y=fab.box.height-15;			
	    p2.x=p1.x-20; p2.y=p1.y;
	    p3.x=p2.x-20; p3.y=p2.y;
	    dx=-dx;
	    raisefrom.x=p1.x;
	    raisefrom.y=p1.y;	
	    myball="redbull.gif";
	}
	whereami.x=p2.x;
	whereami.y=p2.y;
	center=fab.box.width/2;                                             //create and suspend the balls
	b1 = new Ball(fab,applet,p1,applet.getImage(applet.getDocumentBase(),myball),"UP",5,5);
	b1.start();                                                           //because they are in car 
	b1.suspend();
	b2 = new Ball(fab,applet,p2,applet.getImage(applet.getDocumentBase(),myball),"UP",7,7);
	b2.start();  b2.suspend();
	b3 = new Ball(fab,applet,p3,applet.getImage(applet.getDocumentBase(),myball),"UP",9,9);
	b3.start();  b3.suspend();
	applet.registerThreads(whichami,b1,b2,b3);
	    
    }
    public void load(){ // load the carrier by the falling balls
	fab.loadCarrier(this);
	LOADING=false;
	LOADED=true;
	p1.x=whereami.x-20;
	p2.x=p1.x+20;
	p3.x=p2.x+20;
    }
    public void unload(){
	//unload the balls from the corner
	while (UNLOADING==true) {
	    if (b1 != null) 
		b1.resume();
	    try {sleep(300); } catch (InterruptedException e) {} //let  the previous to go
	    if (b3!=null) b3.where.copy(p2);
	    if (b2!=null) b2.where.copy(p1);
	    b1=b2;   
	    b2=b3; b3=null;
	    redraw();
	    if (b1==null)
		UNLOADING=false;
	}
	LOADED=false;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	PERMIT=fab.getPermit_cancelPermit(PERMIT);     //take the permission for the next loading
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~		
    }
    public void showStopSign() // show the stop sign of the car to stop the other car
    {
	if (!PERMIT) return;    // if it has the permit
	Graphics g=fab.getGraphics();
	g.setColor(Color.red);
	g.setXORMode(fab.getBackground());
	int x= whereami.x-50;
	int y= whereami.y-5;
	g.fillOval(x,y,15,15);
	g.fillRect(x+15,y+6,5,3);
	x=whereami.x+35;
	g.fillOval(x,y,15,15);
	g.fillRect(x-5,y+6,5,3);
	g.dispose();
    }
    public void run(){//run method of the thread carrier
	draw();
	while (true){
	    if (!LOADING && !UNLOADING)          //take three action
		move();
	    else if (LOADING)
		load();
	    else unload();
	    try {sleep(30); } catch (InterruptedException e) {}
	}
    }	
    public void draw() {//draw the carrier
	Graphics g=fab.getGraphics();
	int x=whereami.x;
	int y=whereami.y;
	int carX [] = {x-30 ,x-28 ,x-28 ,x+28 ,x+28 ,x+30 ,x+30 ,x-30 ,x-30};
	int carY [] = {y-10 ,y-10 ,y+10 ,y+10 ,y-10 ,y-10 ,y+15 ,y+15 ,y-10   };
	g.setColor(fab.getForeground());
	g.fillPolygon(carX,carY,carX.length);
	if (b1!=null) b1.draw(fab,p1);
	if (b2!=null) b2.draw(fab,p2);
	if (b3!=null) b3.draw(fab,p3);
	g.dispose();
		
    }
    public void redraw() {// 
	Graphics g=fab.getGraphics();
	g.setColor(fab.getBackground());
	g.fillRect(whereami.x-30,whereami.y-10,60,25);
	g.dispose();
	draw();
    }		
    public void move() { // move the car
	Graphics g=fab.getGraphics();
	showStopSign();
	g.setColor(fab.getBackground());
	g.fillRect(whereami.x-30,whereami.y-15,60,25);
	if ( dx > 0 )
	    g.fillRect(whereami.x-30,whereami.y+10,dx,5);
	else    g.fillRect(whereami.x+30+dx,whereami.y+10,Math.abs(dx),5);
		
	whereami.x+=dx;
	dx=delta();
	p1.x=whereami.x-20;
	p2.x=p1.x+20;
	p3.x=p2.x+20;
	draw();
	showStopSign();
	g.dispose();
    }
    public void speed(){ // adjust the speed
	int d= ((int) (4*Math.random()))+3;
	dx=d*(Math.abs(dx)/dx);
    }
    public int delta(){//decide where i am and return the current delta value for moving

	if (whichami.equals("LEFT_CARRIER")) {
	    if (whereami.x <=fab.box.x+30)
		{whereami.x=fab.box.x+30; UNLOADING=true;dx=-dx;}    //unloading position
	    else if (whereami.x >= center)  
		{whereami.x=center;LOADING=true; dx=-dx;}	 ///loading position
	}
	else {  if (whereami.x <=center)                    //right carrier the same 
	    {whereami.x=center;LOADING=true; dx=-dx;}
	else if ( whereami.x >=fab.box.width-30)
	    {whereami.x=fab.box.width-30;UNLOADING=true; dx=-dx;}
	}
	return dx;
    }
    public void refresh()
    {
	applet.refreshBalls();
	//..
    }
    
	
}

//_/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ 
// BALLL
//_/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/ _/ _/ _/ _/ _/_/

class Ball extends Thread {
    Image  image;
    String towards;
    mPoint next = new mPoint();       //next point to move
    mPoint where= new mPoint();   //current place
    int dx;
    int dy;
    SyncApplet applet;               
    int w;                //with and hights of the balls
    int h;
    Environment fab;     // environment canvas , the graphics
    boolean haveTICKET=false;        //initially does not have ticket to get in car
    
    Ball(Environment _f, SyncApplet _applet, mPoint _p, Image _i,String _to, int _dx, int _dy){ 
	//constructor of the ball class
	image=_i;
	where.x=_p.x;
	where.y=_p.y;
	fab=_f;
	towards=_to;
	dx=_dx;
	dy=_dy;
	applet = _applet;
//	    w=image.getWidth(applet);      //does not work initially beacuse of the system speed
//	    h=image.getHeight(applet);
	w=18; h=18;                    // so give the results manually
    }
    public int X(mPoint p){
	return p.x-w/2;
    }
    public int Y(mPoint p) { return p.y-h/2; }
    public void draw(Environment f,mPoint p){    //draw ball image
	Graphics g=f.getGraphics();
	g.setColor(fab.getForeground());
	g.drawImage(image,X(p),Y(p),applet);
	g.dispose();
    }
    public void disappear(Environment f)  //clean the current position to move
    {	
	Graphics g=f.getGraphics();
	g.setColor(fab.getBackground());
	g.fillOval(X(where),Y(where),w,h);
	g.dispose();
    }
    public void move(){// move the ball
	fab.nextOfBall(this);
	disappear(fab);
	draw(fab,next);
	where.copy(next);
	}
    public void beNice()
    {
	try {sleep(50); } catch (InterruptedException e) {}
    }
    public void speed()// change the current speed randomly
    { 
	int d= (int) ( 7*Math.random())+2;
	dx=dy=d;
    }
    public void run(){ //run method of the ball; take only move actions
	draw(fab,where);
	while (true){ 
	    move();
	    try {sleep(30); } catch (InterruptedException e) {}
	}
    }
    public void refresh()
    {
	draw(fab,where);
    }
    
	
}  //end of the ball class
// my point definition
class mPoint {
    int x,y;
    mPoint(){}
    public mPoint(int _x,int _y){
	x=_x; 
	y=_y;
    }
    public void  copy(mPoint p){
	x=p.x; 
	y=p.y;
    }
}
/*************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************
*/
//::::::::::::::
//SyncApplet.class   the main class; take the mouse actions and call the other classes
//::::::::::::::

public class SyncApplet extends Applet {
    Label Status;
    Environment fabric;    //canvas for the graphics and the dynamic ball and cars
    // ThreadGroup tg=new ThreadGroup("FABRIC");
    int numOfActiveThreads;
    Ball [] balls=new Ball[6]; //used just to change the speeds
    Thread [] templist;
    
    boolean PAUSE=false;        //pause the system
    
    public void init() {
        setLayout(new BorderLayout());
        setBackground(Color.gray);
        setForeground(Color.yellow);

        Panel menu=new Panel();
        menu.add(new Button("Start"));
	menu.add(new Button("Shuffle Speeds"));
        //        menu.add(new Button("Pause"));
        menu.add(new Button("Exit"));
        add("North", menu);

        Status=new Label("Status Line");  //shows current choice
        Panel p=new Panel();
        p.setBackground(Color.gray);
        p.add(Status);
        add("South",p);

        fabric=new Environment();      // creates graphics
        fabric.setBackground(Color.blue);
        add("Center", fabric);
    }

    public void paint(Graphics g) {
	fabric.paint(g);  //refresh
    }
    public boolean action(Event evt, Object arg) {//take actions for the menu choises
        String s=(String) arg;
        if (evt.target instanceof Button) {
	    Status.setText(((Button)evt.target).getLabel());
	    if (s.equals("Start")) {               //put the system in action
		RunFabric();
	    } else if (s.equals("Shuffle Speeds")) {  //change speeds randomly
		ShuffleSpeeds();
	    } else if (s.equals("Pause")) {           //suspend and rerun the system
		//if (!PAUSE) {PAUSE= StopThreads();} else {PAUSE=AwakeThreads();}
	    } else if (s.equals("Exit")) {            //exit from the system
		System.exit(0);
		StopThreads();
		System.exit(0);
	    } 
        }
        return true;
    }
    private boolean StopThreads()
    {   
	int i; 
	for (i=0;i<6;i++) {
	    if (balls[i] !=null) 
		balls[i].stop();
	}
	Carrier1.stop();
	Carrier1.stop();
        return true;
    }
    private boolean AwakeThreads()
    {   int i;
//        tg.resume();
        return false;
    }
    private void RunFabric(){//make two car loaded with the balls
	if ( Carrier1==null) {       
	    Carrier1 =new Carrier(fabric,"LEFT_CARRIER",this);
	    Carrier1.start();
	}
//	Carrier1.resume();
	if ( Carrier2==null) {
	    Carrier2 = new Carrier(fabric,"RIGHT_CARRIER",this);
	    Carrier2.start();
	}
//	Carrier2.resume();
    }


    public void registerThreads (String tgname,Ball b1,Ball b2,Ball b3)
    //this method can be avoided by using ThreadGroup class.
    {
	if (tgname.equals("LEFT_CARRIER") ) {
	    balls[0]=b3;
	    balls[1]=b1;
	    balls[2]=b2;
	}
	else {
	    balls[3]=b3;
	    balls[4]=b1;
	    balls[5]=b2;
	}
    }
    private void ShuffleSpeeds()
    {   
	int i;
	for (i=0;i<6;i++) {
	    balls[i].speed();
	}
	Carrier1.speed();
	Carrier2.speed();
    }
    public void refreshBalls()
    {   int i;
	for (i=0;i<6;i++) {
	    if  ((balls[i].where.x>=300)&&(balls[i].where.x<=320))
		balls[i].refresh();
	}
    }
    

    Carrier Carrier1;
    Carrier Carrier2;
} //end of class
